diff --git a/yum/logginglevels.py b/yum/logginglevels.py
index 14c5e73..f441eb9 100644
--- a/yum/logginglevels.py
+++ b/yum/logginglevels.py
@@ -42,7 +42,7 @@ logging.addLevelName(DEBUG_3, "DEBUG_3")
 logging.addLevelName(DEBUG_4, "DEBUG_4")
 
 # High level to effectively turn off logging.
-# For compatability with the old logging system.
+# For compatibility with the old logging system.
 __NO_LOGGING = 100
 logging.raiseExceptions = False
 
@@ -87,7 +87,9 @@ def logLevelFromErrorLevel(error_level):
 
 def logLevelFromDebugLevel(debug_level):
     """ Convert an old-style debug logging level to the new style. """
-    debug_table = {-1 : __NO_LOGGING, 0 : logging.INFO, 1 : INFO_1, 2 : INFO_2,
+    debug_table = {-5 : __NO_LOGGING,
+        -4 : logging.CRITICAL, -3 : logging.ERROR, -2 : logging.WARNING,
+        -1 : __NO_LOGGING, 0 : logging.INFO, 1 : INFO_1, 2 : INFO_2,
         3 : logging.DEBUG, 4 : DEBUG_1, 5 : DEBUG_2, 6 : DEBUG_3, 7 : DEBUG_4}
 
     return __convertLevel(debug_level, debug_table)
@@ -98,7 +100,7 @@ def __convertLevel(level, table):
     try:
         new_level = table[level]
     except KeyError:
-        keys = table.keys()
+        keys = sorted(table.keys())
         # We didn't find the level in the table, check if it's smaller
         # than the smallest level
         if level < keys[0]:
diff --git a/yum/mdparser.py b/yum/mdparser.py
index 8631f06..8d0c678 100644
--- a/yum/mdparser.py
+++ b/yum/mdparser.py
@@ -155,7 +155,8 @@ class PrimaryEntry(BaseEntry):
                 p[name] = child.text
 
             elif name in ('provides', 'requires', 'conflicts', 
-                          'obsoletes'):
+                          'obsoletes',
+                          'suggests', 'enhances', 'recommends', 'supplements'):
                 self.prco[name] = self.getPrco(child)
 
             elif name == 'header-range':
diff --git a/yum/metalink.py b/yum/metalink.py
index aaa4f25..a2c5135 100755
--- a/yum/metalink.py
+++ b/yum/metalink.py
@@ -180,6 +180,7 @@ class MetaLinkRepoMD:
         self.repomd = None
         self.old_repomds = []
         self.mirrors = []
+        self._host2mc = {}
         if not os.path.exists(filename):
             raise MetaLinkRepoErrorParseFail, "File %s does not exist" %filename
         try:
@@ -206,7 +207,7 @@ class MetaLinkRepoMD:
                 self.old_repomds.append(MetaLinkFile(celem))
 
             for celem in elem.findall(__ML_RESOURCES__):
-                max_connections = int(celem.get("maxconnections"))
+                max_connections = int(celem.get("maxconnections") or 2)
                 for uelem in celem:
                     if uelem.tag == "{%s}url"  % __XML_NS_ML__:
                         self.mirrors.append(MetaLinkURL(uelem, max_connections))
@@ -225,8 +226,6 @@ class MetaLinkRepoMD:
         # Get the hostname from a url, stripping away any usernames/passwords
         # Borrowd from fastestmirror
         url2host = lambda url: url.split('/')[2].split('@')[-1]
-        hosts = set() # Don't want multiple urls for one host in plain mode
-                      # The list of URLs is sorted, so http is before ftp
 
         for mirror in self.mirrors:
             url = mirror.url
@@ -237,9 +236,9 @@ class MetaLinkRepoMD:
             elif (url.startswith("http:") or url.startswith("ftp:") or
                   url.startswith("https:")):
                 host = url2host(url)
-                if host in hosts:
+                if host in self._host2mc:
                     continue
-                hosts.add(host)
+                self._host2mc[host] = mirror
             else:
                 continue
 
diff --git a/yum/misc.py b/yum/misc.py
index 2f6ddfe..6850ae2 100644
--- a/yum/misc.py
+++ b/yum/misc.py
@@ -5,9 +5,11 @@ Assorted utility functions for yum.
 
 import types
 import os
+import sys
 import os.path
 from cStringIO import StringIO
 import base64
+import binascii
 import struct
 import re
 import errno
@@ -21,6 +23,7 @@ import fnmatch
 import bz2
 import gzip
 import shutil
+import urllib
 _available_compression = ['gz', 'bz2']
 try:
     import lzma
@@ -38,13 +41,11 @@ except ImportError:
 try:
     import hashlib
     _available_checksums = set(['md5', 'sha1', 'sha256', 'sha384', 'sha512'])
-    _default_checksums = ['sha256']
 except ImportError:
     # Python-2.4.z ... gah!
     import sha
     import md5
     _available_checksums = set(['md5', 'sha1'])
-    _default_checksums = ['sha1']
     class hashlib:
 
         @staticmethod
@@ -55,6 +56,20 @@ except ImportError:
                 return sha.new()
             raise ValueError, "Bad checksum type"
 
+# some checksum types might be disabled
+for ctype in list(_available_checksums):
+    try:
+        hashlib.new(ctype)
+    except:
+        print >> sys.stderr, 'Checksum type %s disabled' % repr(ctype)
+        _available_checksums.remove(ctype)
+for ctype in 'sha256', 'sha1':
+    if ctype in _available_checksums:
+        _default_checksums = [ctype]
+        break
+else:
+    raise ImportError, 'broken hashlib'
+
 from Errors import MiscError
 # These are API things, so we can't remove them even if they aren't used here.
 # pylint: disable-msg=W0611
@@ -95,6 +110,19 @@ def re_glob(s):
         _re_compiled_glob_match = re.compile('[*?]|\[.+\]').search
     return _re_compiled_glob_match(s)
 
+def compile_pattern(pat, ignore_case=False):
+    """ Compile shell wildcards, return a 'match' function. """
+    if re_glob(pat):
+        try:
+            flags = ignore_case and re.I or 0
+            return re.compile(fnmatch.translate(pat), flags).match
+        except re.error:
+            pass # fall back to exact match
+    if ignore_case:
+        pat = pat.lower()
+        return lambda s: s.lower() == pat
+    return lambda s: s == pat
+
 _re_compiled_filename_match = None
 def re_filename(s):
     """ Tests if a string could be a filename. We still get negated character
@@ -106,8 +134,9 @@ def re_filename(s):
 
 def re_primary_filename(filename):
     """ Tests if a filename string, can be matched against just primary.
-        Note that this can produce false negatives (but not false
-        positives). Note that this is a superset of re_primary_dirname(). """
+        Note that this can produce false negatives (Eg. /b?n/zsh) but not false
+        positives (because the former is a perf hit, and the later is a
+        failure). Note that this is a superset of re_primary_dirname(). """
     if re_primary_dirname(filename):
         return True
     if filename == '/usr/lib/sendmail':
@@ -322,7 +351,7 @@ def checksum(sumtype, file, CHUNK=2**16, datasize=None):
         if type(file) not in types.StringTypes:
             fo = file # assume it's a file-like-object
         else:           
-            fo = open(file, 'r', CHUNK)
+            fo = open(file, 'r')
 
         data = Checksums([sumtype])
         while data.read(fo, CHUNK):
@@ -331,7 +360,6 @@ def checksum(sumtype, file, CHUNK=2**16, datasize=None):
 
         if type(file) is types.StringType:
             fo.close()
-            del fo
             
         # This screws up the length, but that shouldn't matter. We only care
         # if this checksum == what we expect.
@@ -410,6 +438,17 @@ def procgpgkey(rawkey):
     # Decode and return
     return base64.decodestring(block.getvalue())
 
+def gpgkey_fingerprint_ascii(info, chop=4):
+    ''' Given a key_info data from getgpgkeyinfo(), return an ascii
+    fingerprint. Chop every 4 ascii values, as that is what GPG does. '''
+    # First "duh" ... it's a method...
+    fp = info['fingerprint']()
+    fp = binascii.hexlify(fp)
+    if chop:
+        fp = [fp[i:i+chop] for i in range(0, len(fp), chop)]
+        fp = " ".join(fp)
+    return fp
+
 def getgpgkeyinfo(rawkey, multiple=False):
     '''Return a dict of info for the given ASCII armoured key text
 
@@ -611,6 +650,8 @@ def getCacheDir(tmpdir='/var/tmp', reuse=True, prefix='yum-'):
     try:
         usertup = pwd.getpwuid(uid)
         username = usertup[0]
+        # we prefer ascii-only paths
+        username = urllib.quote(username)
     except KeyError:
         return None # if it returns None then, well, it's bollocksed
 
@@ -744,8 +785,9 @@ def _decompress_chunked(source, dest, ztype):
     while True:
         try:
             data = s_fn.read(1024000)
-        except IOError:
-            break
+        except (OSError, IOError, EOFError), e:
+            msg = "Error reading from file %s: %s" % (source, str(e))
+            raise Errors.MiscError, msg
         
         if not data: break
 
@@ -868,67 +910,39 @@ def seq_max_split(seq, max_entries):
     ret.append(seq[beg:])
     return ret
 
-def _ugly_utf8_string_hack(item):
-    """hands back a unicoded string"""
-    # this is backward compat for handling non-utf8 filenames 
-    # and content inside packages. :(
-    # content that xml can cope with but isn't really kosher
+_deletechars = ''.join(chr(i) for i in range(32) if i not in (9, 10, 13))
 
-    # if we're anything obvious - do them first
-    if item is None:
-        return ''
-    elif isinstance(item, unicode):    
-        return item
-    
-    # this handles any bogon formats we see
-    du = False
-    try:
-        x = unicode(item, 'ascii')
-        du = True
-    except UnicodeError:
-        encodings = ['utf-8', 'iso-8859-1', 'iso-8859-15', 'iso-8859-2']
-        for enc in encodings:
-            try:
-                x = unicode(item, enc)
-            except UnicodeError:
-                pass
-                
-            else:
-                if x.encode(enc) == item:
-                    if enc != 'utf-8':
-                        print '\n%s encoding on %s\n' % (enc, item)
-                    return x.encode('utf-8')
-    
-    
-    # Kill bytes (or libxml will die) not in the small byte portion of:
-    #  http://www.w3.org/TR/REC-xml/#NT-Char
-    # we allow high bytes, if it passed the utf8 check above. Eg.
-    # good chars = #x9 | #xA | #xD | [#x20-...]
-    newitem = ''
-    bad_small_bytes = range(0, 8) + [11, 12] + range(14, 32)
-    for char in item:
-        if ord(char) in bad_small_bytes:
-            pass # Just ignore these bytes...
-        elif not du and ord(char) > 127:
-            newitem = newitem + '?' # byte by byte equiv of escape
-        else:
-            newitem = newitem + char
-    return newitem
-
-__cached_saxutils = None
 def to_xml(item, attrib=False):
-    global __cached_saxutils
-    if __cached_saxutils is None:
-        import xml.sax.saxutils
-        __cached_saxutils = xml.sax.saxutils
+    """ Returns xml-friendly utf-8 encoded string.
+        Accepts utf-8, iso-8859-1, or unicode.
+    """
+    if type(item) is str:
+        # check if valid utf8
+        try: unicode(item, 'utf-8')
+        except UnicodeDecodeError:
+            # assume iso-8859-1
+            item = unicode(item, 'iso-8859-1').encode('utf-8')
+    elif type(item) is unicode:
+        item = item.encode('utf-8')
+    elif item is None:
+        return ''
+    else:
+        raise ValueError, 'String expected, got %s' % repr(item)
 
-    item = _ugly_utf8_string_hack(item)
-    item = to_utf8(item)
+    # compat cruft...
     item = item.rstrip()
+
+    # kill ivalid low bytes
+    item = item.translate(None, _deletechars)
+
+    # quote reserved XML characters
+    item = item.replace('&', '&amp;')
+    item = item.replace('<', '&lt;')
+    item = item.replace('>', '&gt;')
     if attrib:
-        item = __cached_saxutils.escape(item, entities={'"':"&quot;"})
-    else:
-        item = __cached_saxutils.escape(item)
+        item = item.replace('"', '&quot;')
+        item = item.replace("'", '&apos;')
+
     return item
 
 def unlink_f(filename):
@@ -937,17 +951,19 @@ def unlink_f(filename):
     try:
         os.unlink(filename)
     except OSError, e:
-        if e.errno != errno.ENOENT:
+        if e.errno not in (errno.ENOENT, errno.EPERM, errno.EACCES, errno.EROFS):
             raise
 
-def stat_f(filename):
+def stat_f(filename, ignore_EACCES=False):
     """ Call os.stat(), but don't die if the file isn't there. Returns None. """
     try:
         return os.stat(filename)
     except OSError, e:
-        if e.errno not in (errno.ENOENT, errno.ENOTDIR):
-            raise
-        return None
+        if e.errno in (errno.ENOENT, errno.ENOTDIR):
+            return None
+        if ignore_EACCES and e.errno == errno.EACCES:
+            return None
+        raise
 
 def _getloginuid():
     """ Get the audit-uid/login-uid, if available. None is returned if there
@@ -976,7 +992,6 @@ def getloginuid():
 
 # ---------- i18n ----------
 import locale
-import sys
 def setup_locale(override_codecs=True, override_time=False):
     # This test needs to be before locale.getpreferredencoding() as that
     # does setlocale(LC_CTYPE, "")
@@ -992,9 +1007,17 @@ def setup_locale(override_codecs=True, override_time=False):
         locale.setlocale(locale.LC_ALL, 'C')
         
     if override_codecs:
-        import codecs
-        sys.stdout = codecs.getwriter(locale.getpreferredencoding())(sys.stdout)
-        sys.stdout.errors = 'replace'
+        class UnicodeStream:
+            def __init__(self, stream, encoding):
+                self.stream = stream
+                self.encoding = encoding
+            def write(self, s):
+                if isinstance(s, unicode):
+                    s = s.encode(self.encoding, 'replace')
+                self.stream.write(s)
+            def __getattr__(self, name):
+                return getattr(self.stream, name)
+        sys.stdout = UnicodeStream(sys.stdout, locale.getpreferredencoding())
 
 
 def get_my_lang_code():
@@ -1077,6 +1100,23 @@ def get_uuid(savepath):
             pass
         
         return myid
+
+class _Dynamic_UUID(object):
+    def __init__(self, filename):
+        self.filename = filename
+        self.uuid = None
+
+    def __str__(self):
+        if self.uuid is None:
+            self.uuid = get_uuid(self.filename)
+        return self.uuid
+
+    def __unicode__(self):
+        return to_unicode(self.__str__())
+
+def get_uuid_obj(savepath):
+    """ Like get_uuid() but doesn't create the uuid file until it's needed. """
+    return _Dynamic_UUID(savepath)
         
 def decompress(filename, dest=None, fn_only=False, check_timestamps=False):
     """take a filename and decompress it into the same relative location.
@@ -1105,17 +1145,28 @@ def decompress(filename, dest=None, fn_only=False, check_timestamps=False):
             out = filename.replace('.xz', '')
         
     else:
-        out = filename # returning the same file since it is not compressed
-        ztype = None
+        return filename # returning the same file since it is not compressed
     
-    if ztype and not fn_only:
-        if check_timestamps:
-            fi = stat_f(filename)
-            fo = stat_f(out)
-            if fi and fo and fo.st_mtime > fi.st_mtime:
+    if check_timestamps:
+        fi = stat_f(filename)
+        fo = stat_f(out)
+        if fi and fo:
+            # Eliminate sub second precision in mtime before comparison,
+            # see http://bugs.python.org/issue14127
+            if int(fo.st_mtime) == int(fi.st_mtime):
                 return out
+            if fn_only:
+                # out exists but not valid
+                return None
 
-        _decompress_chunked(filename, out, ztype)
+    if not fn_only:
+        try:
+            _decompress_chunked(filename, out, ztype)
+            if check_timestamps and fi:
+                os.utime(out, (fi.st_mtime, fi.st_mtime))
+        except:
+            unlink_f(out)
+            raise
         
     return out
     
@@ -1123,13 +1174,14 @@ def repo_gen_decompress(filename, generated_name, cached=False):
     """ This is a wrapper around decompress, where we work out a cached
         generated name, and use check_timestamps. filename _must_ be from
         a repo. and generated_name is the type of the file. """
-    dest = os.path.dirname(filename)
-    dest += '/gen'
-    if not os.path.exists(dest):
-        os.makedirs(dest, mode=0755)
-    dest += '/' + generated_name
-    return decompress(filename, dest=dest, check_timestamps=True,fn_only=cached)
-    
+    dest = os.path.dirname(filename) + '/gen/' + generated_name
+    try:
+        return decompress(filename, dest=dest, check_timestamps=True)
+    except (OSError, IOError), e:
+        if cached and e.errno == errno.EACCES:
+            return None
+        raise
+
 def read_in_items_from_dot_dir(thisglob, line_as_list=True):
     """takes a glob of a dir (like /etc/foo.d/*.foo)
        returns a list of all the lines in all the files matching
@@ -1175,3 +1227,22 @@ def cElementTree_xmlparse(filename):
     """ Lazily load/run: cElementTree.parse """
     _cElementTree_import()
     return __cached_cElementTree.parse(filename)
+
+def filter_pkgs_repoid(pkgs, repoid):
+    """ Given a list of packages, filter them for those "in" the repoid.
+    uses from_repo for installed packages, used by repo-pkgs commands. """
+
+    if repoid is None:
+        return pkgs
+
+    ret = []
+    for pkg in pkgs:
+        if pkg.repoid == 'installed':
+            if 'from_repo' not in pkg.yumdb_info:
+                continue
+            if pkg.yumdb_info.from_repo != repoid:
+                continue
+        elif pkg.repoid != repoid:
+            continue
+        ret.append(pkg)
+    return ret
diff --git a/yum/packageSack.py b/yum/packageSack.py
index 4af563a..a702ac1 100644
--- a/yum/packageSack.py
+++ b/yum/packageSack.py
@@ -282,11 +282,7 @@ class PackageSackBase(object):
 
         specs = {}
         for p in pkgspecs:
-            if misc.re_glob(p):
-                restring = fnmatch.translate(p)
-                specs[p] = re.compile(restring)
-            else:
-                specs[p] = p
+            specs[p] = misc.compile_pattern(p)
 
         #  We don't use simplePkgList() here because that loads all of the
         # rpmdb, if we are Eg. doing a "remove PackageKit".
@@ -304,13 +300,12 @@ class PackageSackBase(object):
                 ))
                 
             for (term,query) in specs.items():
-                if term == query:
-                    if query in names:
-                        exactmatch.append(self.searchPkgTuple(pkgtup)[0])
-                        unmatched.discard(term)
+                if term in names:
+                    exactmatch.append(self.searchPkgTuple(pkgtup)[0])
+                    unmatched.discard(term)
                 else:
                     for n in names:
-                        if query.match(n):
+                        if query(n):
                             matched.append(self.searchPkgTuple(pkgtup)[0])
                             unmatched.discard(term)
         return misc.unique(exactmatch), misc.unique(matched), list(unmatched)
@@ -445,6 +440,7 @@ class MetaSack(PackageSackBase):
         nobsdict = {}
         last_name = ''
         last_pkg = None
+        last_pkgtup = None
         #  It takes about 0.2 of a second to convert these into packages, just
         # so we can sort them, which is ~40% of this functions time. So we sort
         # the pkgtups "by hand".
@@ -624,6 +620,8 @@ class MetaSack(PackageSackBase):
 class PackageSack(PackageSackBase):
     """represents sets (sacks) of Package Objects"""
     def __init__(self):
+        PackageSackBase.__init__(self)
+
         self.nevra = {} #nevra[(Name, Epoch, Version, Release, Arch)] = []
         self.obsoletes = {} #obs[obsoletename] = [pkg1, pkg2, pkg3] 
                  #the package lists are packages that obsolete the key name
